--#########################################
-- Modifications for the exporter for the shared repositiory

-- New table for the date of the last export for each application
create table ApplicationLastExport (
    LastExportId bigint generated by default as identity (start with 1),
    ComponentId bigint,
    LastExportDate timestamp,
    ToExport bit,
    primary key (LastExportId),
    unique (ComponentId)
);    
  
create table Job (
    JobId bigint generated by default as identity (start with 1),
    JobName varchar(100),
    JobStatus varchar(100),
    JobDate timestamp,
    primary key (JobId)
);

alter table ApplicationLastExport alter ToExport set default 0 ;
        
-- constrain between the table component(application) and the table lastexport
alter table ApplicationLastExport 
    add constraint FK1E3E973AB660AF72 
    foreign key (ComponentId) 
    references Component;


        
        
--#################################################
-- Some constrains don't have the "on delete cascade" parameter
-- For homogeneity between the db implementation we add it
-- So we destroy the constrain before recreate it.         
alter table TaskRef 
		drop constraint FK797F8AE76E45E0C;        
		
alter table TaskRef 
        add constraint FK797F8AE76E45E0C 
        foreign key (TaskId) 
        references Task
		on delete cascade;
		
alter table UserAccess 
		drop constraint FKB60A252FB4DCCF05;        
		
alter table UserAccess 
        add constraint FKB60A252FB4DCCF05 
        foreign key (ApplicationId) 
        references Component
		on delete cascade;
	
alter table User_Rights 
		drop constraint FK21885CCBB4DCCF05;        		
		
alter table User_Rights 
        add constraint FK21885CCBB4DCCF05 
        foreign key (ApplicationId) 
        references Component
        on delete cascade; 
        
alter table Volumetry_Measures 
		drop constraint FK92AE693393A162FA;            
        
alter table Volumetry_Measures 
        add constraint FK92AE693393A162FA 
        foreign key (VolumetryId) 
        references displayConf
        on delete cascade;
        
        

--#########################################
-- Modifications needed to add the auditor role

Insert into ProfileBO
   (NAME)
 Values
   ('bo.profile.name.auditor');

Insert into Profile_Rights
   (PROFILEID, RIGHTS_VALUE, ATOMICRIGHTSID)
 Values
   ((select PROFILEID from ProfileBO where NAME ='bo.profile.name.auditor'), 'bo.profile.action.readonly', (select ATOMICRIGHTSID from AtomicRights where NAME = 'atomicright.type.portal_administration'));
Insert into Profile_Rights
   (PROFILEID, RIGHTS_VALUE, ATOMICRIGHTSID)
 Values
   ((select PROFILEID from ProfileBO where NAME ='bo.profile.name.auditor'), 'bo.profile.action.readwrite', (select ATOMICRIGHTSID from AtomicRights where NAME = 'atomicright.type.project_quality_result'));
Insert into Profile_Rights
   (PROFILEID, RIGHTS_VALUE, ATOMICRIGHTSID)
 Values
   ((select PROFILEID from ProfileBO where NAME ='bo.profile.name.auditor'), 'bo.profile.action.none', (select ATOMICRIGHTSID from AtomicRights where NAME = 'atomicright.type.project_administration'));
Insert into Profile_Rights
   (PROFILEID, RIGHTS_VALUE, ATOMICRIGHTSID)
 Values
   ((select PROFILEID from ProfileBO where NAME ='bo.profile.name.auditor'), 'bo.profile.action.readwrite', (select ATOMICRIGHTSID from AtomicRights where NAME = 'atomicright.type.project_component_result'));
Insert into Profile_Rights
   (PROFILEID, RIGHTS_VALUE, ATOMICRIGHTSID)
 Values
   ((select PROFILEID from ProfileBO where NAME ='bo.profile.name.auditor'), 'bo.profile.action.readonly', (select ATOMICRIGHTSID from AtomicRights where NAME = 'atomicright.type.project_creation'));
Insert into Profile_Rights
   (PROFILEID, RIGHTS_VALUE, ATOMICRIGHTSID)
 Values
   ((select PROFILEID from ProfileBO where NAME ='bo.profile.name.auditor'), 'bo.profile.action.readwrite', (select ATOMICRIGHTSID from AtomicRights where NAME = 'atomicright.type.documentation'));

Insert into UserBO
   ( MATRICULE, PASSWORD,PROFILEID)
 Values
   ( 'squaleauditor','audit',(select PROFILEID from ProfileBO where NAME ='bo.profile.name.default'));



-- #####################################################
-- Modification for #228 
   
alter table QualityResult_Comment 
		drop constraint FKD36C3ADCCCF6BB41;            
        
alter table QualityResult_Comment 
        add constraint FKD36C3ADCCCF6BB41 
        foreign key (QualityResultId) 
        references QualityResult
        on delete cascade;



alter table AuditBO alter SQUALE_VERSION set default '5.3' ;